﻿Imports System.Drawing.Drawing2D
Imports System.Windows.Forms

Public Class FrmInputBox

    ' Define a local variable to store the property value.
    Private strInputString As String
    ' Define the property.
    Public Property InputText() As String
        Get
            ' The Get property procedure is called when the value
            ' of a property is retrieved.
            Return strInputString
        End Get
        Set(ByVal value As String)
            ' The Set property procedure is called when the value 
            ' of a property is modified.  The value to be assigned
            ' is passed in the argument to Set.
            strInputString = value
        End Set
    End Property

    ' Hintergrund-Farbverlauf erstellen (von Dieter Otter)
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' Größe der Form
        Dim oRect As New Rectangle(0, 0, Me.Width, Me.Height)

        ' Neues Brush-Objekt mit den gewünschten Farben und
        ' Farbverlauf-Richtung erstellen
        Dim oBrush As New LinearGradientBrush(oRect, Color.White, Color.LightGray, _
          LinearGradientMode.Vertical)

        ' Hintergrund-Farbverlauf anzeigen
        e.Graphics.FillRectangle(oBrush, oRect)
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        strInputString = Me.txtInputText.Text
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

End Class