﻿Public Class FrmLesezeichen

    'Dieser Source-Code kann frei verwendet werden!
    'für evtl. auftretende Schäden wird nicht gehaftet

    'Dank an Dieter (für den hier zum Teil verwendeten Source-Codes des VB-Net Demo-Projekts sev.FTP v1.0 .NET)
    '(neues ToolStripMenuItem einfügen)

    'die Möglichkeit eigene Lesezeichen zu vergeben ist an sich nichts neues!
    '(z.B. auch im Source-Code Bereich der VB 2008 Entwicklungsumgebung gibt es diese Möglichkeit)


    'am besten funktioniert das Lesezeichen setzen mit WordWrap = False (RichTextBox)
    '(wenn man Text als Lesezeichen (Bookmark) markiert hat)

    '(man könnte jetzt z.B. noch, entsprechend der geöffneten Datei, die vorhandenen Lesezeichen abspeichern,
    'damit sie (bei Bedarf) beim nächsten öffnen der Datei gleich zu Verfügung stehen.)


    Private Declare Function SendMessage Lib "USER32" Alias "SendMessageA" _
    (ByVal hwnd As Int32, ByVal wMsg As Int32, ByVal wParam As Int32, ByVal lParam As  _
    Int32) As Int32

    Private Const vbQuote As String = """"
    Dim sItemText As String

#Region "Datei öffnen"
    Private Sub ÖffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ÖffnenToolStripMenuItem.Click
        Try
            Dim myOpenFileDialog As New OpenFileDialog
            With myOpenFileDialog
                .Title = "Datei öffnen"
                .Filter = "Text-Dateien *.txt|*.txt|RichTextDateien *.rtf|*.rtf|alle Dateien *.*|*.*"
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Call DelBookmarks()
                        Dim fileextension As String = Mid(.FileName, InStrRev(.FileName, "."))

                        Select Case StrConv(fileextension, VbStrConv.Lowercase)

                            Case ".txt"
                                Me.RichTextBox1.LoadFile(.FileName, RichTextBoxStreamType.PlainText)
                            Case ".rtf"
                                Me.RichTextBox1.LoadFile(.FileName, RichTextBoxStreamType.RichText)
                            Case Else

                                Dim fileReader As System.IO.StreamReader
                                Dim stringReader As String
                                fileReader = My.Computer.FileSystem.OpenTextFileReader(.FileName)

                                stringReader = fileReader.ReadToEnd()
                                'stringReader = TextUmlauteprüfen(stringReader) '?

                                With Me
                                    .RichTextBox1.Clear()
                                    .RichTextBox1.Text = stringReader
                                    fileReader.Close()
                                    My.Computer.FileSystem.OpenTextFileReader(myOpenFileDialog.FileName).Close()
                                End With

                        End Select
                    End If
                End If
                .Dispose()
            End With
        Catch ex As Exception

        End Try
    End Sub
#End Region

#Region "Lesezeichen (Bookmarks) initialisieren, benennen bzw. anspringen und löschen"

#Region "Lesezeichen (Bookmark) initialisieren und einfügen"
    Public Sub initBookmarkItem()
        Dim sSelText As String = ""
        With Me.RichTextBox1
            'prüfen ob Text selektiert wurde
            If .SelectedText <> "" Then
                sSelText = .SelectedText
                'auf Leerstellen prüfen (Start soll kein Leerzeichen sein)
                If InStr(sSelText, " ") Then
                    For i As Integer = .SelectionStart To Len(.Text)
                        If Mid(.Text, i + 1, 1) <> " " Then
                            .SelectionLength = 0
                            .SelectionStart = i
                            Exit For
                        End If
                    Next
                End If
            Else 'nur Position
                sSelText = .SelectionStart
            End If
        End With

        Dim myInputBox As New FrmInputBox
        With myInputBox
            .Text = "Lesezeichen erstellen"
            .lblHinweistext.Text = "Gib bitte einen aussagekräftigen Namen für dieses Lesezeichen ein!" _
            & vbCrLf & vbCrLf & "(Grundlage des Lesezeichens ist die Position bzw. der markierte Text der angesprungen werden soll, nicht der vergebene Name)"
            .txtInputText.Text = Trim(sSelText)
            If .ShowDialog = Windows.Forms.DialogResult.OK Then
                If .InputText <> "" Then
                    Dim iSelStart As Integer = Me.RichTextBox1.SelectionStart

                    With Me.tbbtnBookmarkItems
                        Dim FirstCharCurrentLine As Integer
                        With Me.RichTextBox1
                            FirstCharCurrentLine = .GetFirstCharIndexOfCurrentLine()
                        End With

                        'ein neues ToolStripMenuItem entsprechend erzeugen und einfügen
                        Dim oItem As New ToolStripMenuItem(myInputBox.InputText)
                        'Werte:     Startpunkt  "|" 1. Zeichen der Zeile     "|" Position oder Text
                        oItem.Tag = iSelStart & "|" & FirstCharCurrentLine & "|" & Trim(sSelText)
                        oItem.Image = Me.ImageList1.Images.Item(0)
                        AddHandler oItem.Click, AddressOf tbbtnBookmarkItem_Click
                        .DropDownItems.Add(oItem)

                        'ein neues ToolStripMenuItem zum Löschen des entsprechendem MenuItems erzeugen und einfügen
                        Dim oDelItem As New ToolStripMenuItem("lösche: " & vbQuote & myInputBox.InputText & vbQuote)
                        'hier den entsprechenden Namen des Neuen Lesezeichens speichern
                        oDelItem.Tag = myInputBox.InputText
                        oDelItem.Image = Me.ImageList1.Images.Item(1)
                        AddHandler oDelItem.Click, AddressOf tbbtnDelBookmarkItem_Click
                        Me.tbbtnDelBookmarkItem.DropDownItems.Add(oDelItem)

                        Call tbbtnBookmarkItemsUpdaten()
                    End With

                End If
            End If
            Call tbbtnBookmarkItemsUpdaten()
            .Dispose()
        End With
    End Sub
#End Region

#Region "Lesezeichen (Bookmark) suchen"
    Private Sub gotoBookmark(ByVal sTag As String, ByVal bToolStripMenuItem As Boolean, _
                                Optional ByVal ToolStripMenuItem As ToolStripMenuItem = Nothing, _
                                Optional ByVal ItemText As String = "")
        Try

            Dim bFind As Boolean = False

            Dim ArrayLesezeichenTag() As String = Split(sTag, "|")
            Dim OZähler As Integer = -1
            For i As Integer = 0 To ArrayLesezeichenTag.Length - 1
                If ArrayLesezeichenTag(i) <> "" Then
                    OZähler += 1
                    ArrayLesezeichenTag(OZähler) = ArrayLesezeichenTag(i)
                End If
            Next

            ReDim Preserve ArrayLesezeichenTag(OZähler)
            'Ergebnis
            'ArrayLesezeichenTag(0) = Start-Position des Lesezeichens
            'ArrayLesezeichenTag(1) = Position des 1. Zeichens der entsprechenden Zeile
            'ArrayLesezeichenTag(2) = Start-Position oder Text des Lesezeichens
            With Me
                'prüfen ob das Lesezeichen angesprungen werden kann
                If IsNumeric(ArrayLesezeichenTag(0)) Then
                    With .RichTextBox1
                        '**********************************************************************************
                        'für den Fall dass in den Zeilen vor dem Lesezeichen Änderungen vorgenommen wurden,
                        'den evtl. Differenz-Wert ausrechnen und entsprechend berücksichtigen
                        '**********************************************************************************
                        Dim PosBookmarkFirstChar As Integer = ArrayLesezeichenTag(1)
                        Dim PosAktFirstChar As Integer = .GetFirstCharIndexFromLine(.GetLineFromCharIndex(ArrayLesezeichenTag(0)))
                        Dim iDiff As Integer = PosAktFirstChar - PosBookmarkFirstChar
                        '**********************************************************************************
                        .SelectionStart = Int(ArrayLesezeichenTag(0) + iDiff)
                        '**********************************************************************************

                        'prüfen ob ein Text als Lesezeichen markiert wurde
                        If ArrayLesezeichenTag(2) <> "" Then
                            If IsNumeric(ArrayLesezeichenTag(2)) Then
                                'nur eine Positionsangabe
                                .SelectionLength = 0
                                bFind = True
                            Else
                                'markierter Text
                                .SelectionLength = Len(ArrayLesezeichenTag(2))
                                bFind = True
                                'auf Übereinstimmung hin prüfen
                                If .SelectedText <> ArrayLesezeichenTag(2) Then
                                    'bei keiner Übereinstimmung aktuelle Zeile markieren und
                                    'prüfen ob sich das Lesezeichen in dieser Zeile befindet
                                    '******************************************************************
                                    Dim EM_GETSEL = &HB0
                                    Dim EM_LINEFROMCHAR As Long = &HC9
                                    Dim EM_LINELENGTH = &HC1
                                    Dim EM_LINEINDEX = &HBB

                                    Dim lngCursorPos As Integer
                                    Dim lngLineIndex As Integer
                                    Dim lngFirstCharPos As Integer
                                    Dim lngLineLength As Integer
                                    'Cursor-Position ermitteln:
                                    lngCursorPos = SendMessage(.Handle, EM_GETSEL, _
                                          0, 0&) \ &H10000

                                    'Zeilen-Index ermitteln:
                                    lngLineIndex = SendMessage(.Handle, EM_LINEFROMCHAR, _
                                          lngCursorPos, 0&)

                                    'Position des erstens Zeichens in Zeile ermitteln:
                                    lngFirstCharPos = SendMessage(.Handle, EM_LINEINDEX, _
                                          lngLineIndex, 0&)

                                    'Anzahl Zeichen in Zeile ermitteln:
                                    lngLineLength = SendMessage(.Handle, EM_LINELENGTH, _
                                          lngFirstCharPos, 0&)

                                    .SelectionStart = SendMessage(.Handle, EM_LINEINDEX, lngLineIndex, 0)
                                    .SelectionLength = SendMessage(.Handle, EM_LINELENGTH, lngFirstCharPos, 0)

                                    Dim sSelText As String = .SelectedText
                                    '******************************************************************

                                    'wurde das Lesezeichen doch noch gefunden?
                                    '(kann bei einem Mehrfachvorhandensein ein "falsches" Ergebnis der Suche zurück geben)
                                    If InStr(StrConv(sSelText, VbStrConv.Lowercase), StrConv(ArrayLesezeichenTag(2), VbStrConv.Lowercase)) Then
                                        'wurde gefunden
                                        '(Änderungen vor dem Lesezeichen in der gleichen Zeile werden hier berücksichtigt)
                                        .SelectionLength = 0
                                        'Cursor entsprechend setzen und...
                                        .SelectionStart = lngFirstCharPos + (InStrRev(sSelText, ArrayLesezeichenTag(2))) - 1
                                        'markieren
                                        .SelectionLength = Len(ArrayLesezeichenTag(2))
                                        bFind = True
                                    Else
                                        bFind = False
                                        'wurde nicht gefunden
                                        MsgBox("Dein Lesezeichen:" & vbCrLf & vbCrLf & vbQuote & ArrayLesezeichenTag(2) & vbQuote _
                                              & vbCrLf & vbCrLf & "wurde nicht gefunden bzw. der Text wurde geändert!" _
                                              & vbCrLf & "Das Lesezeichen " & vbQuote & ArrayLesezeichenTag(2) & vbQuote _
                                              & " wird aus der Liste entfernt!", _
                                              MsgBoxStyle.Exclamation, "Lesezeichen nicht gefunden")
                                        .SelectionLength = 0

                                        With Me.tbbtnBookmarkItems
                                            For i As Integer = 0 To .DropDownItems.Count - 1
                                                If .DropDownItems.Item(i).Text = sItemText Then
                                                    'nicht gefundenes Lesezeichen (DropDownMenü) entfernen
                                                    .DropDownItems.Remove(.DropDownItems.Item(i))
                                                    With Me.tbbtnDelBookmarkItem.DropDownItems
                                                        .Remove(.Item(i))
                                                    End With
                                                    Exit For
                                                End If
                                            Next
                                        End With
                                    End If

                                End If
                            End If
                        End If
                    End With
                End If
                If bFind = True Then
                    If bToolStripMenuItem = True Then
                        .tbbtnBookmarkItems.Tag = sTag
                        .tbbtnBookmarkItems.ToolTipText = "gehe zu Lesezeichen " & ItemText
                    End If
                Else
                    .tbbtnBookmarkItems.Tag = ""
                    .tbbtnBookmarkItems.ToolTipText = "gehe zu Lesezeichen..."
                End If
                Call tbbtnBookmarkItemsUpdaten()
            End With

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler")
        End Try
    End Sub
#End Region

    Private Sub tbbtnBookmarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnBookmarker.Click
        Call initBookmarkItem()
    End Sub

    Private Sub tbbtnBookmarkItems_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnBookmarkItems.ButtonClick
        Try

            With Me.tbbtnBookmarkItems
                'nur Lesezeichen suchen wenn .Tag <> "" ist
                If .Tag <> "" Then
                    'entsprechend zuweisen und splitten
                    Call gotoBookmark(.Tag, False, , sItemText)
                End If
            End With

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

#Region "ToolStripMenuItem Sub´s für die Suche und das Löschen von Lesezeichen (Bookmarks)"
    'entsprechend der Auswahl, an die Stelle des entsprechenden Lesezeichens springen
    Private Sub tbbtnBookmarkItem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            Dim Item As ToolStripMenuItem = sender
            'auf Inhalt prüfen
            If Item.Text <> "" Then
                sItemText = Item.Text
                'entsprechend zuweisen und splitten
                Dim strItemTag As String = Item.Tag
                Call gotoBookmark(strItemTag, True, Item, Item.Text)
            End If
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    'entsprechend der Auswahl, das entsprechende Lesezeichen löschen
    Public Sub tbbtnDelBookmarkItem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Try
            Dim Item As ToolStripMenuItem = sender
            'auf Inhalt prüfen
            If Item.Text <> "" Then
                'entsprechend zuweisen (beinhaltet den angezeigten Namen des Lesezeichens)
                Dim strItemTag As String = Item.Tag

                With Me.tbbtnBookmarkItems.DropDownItems
                    If .Count > 0 Then
                        For i As Integer = .Count - 1 To 0 Step -1
                            'Textvergleich
                            If .Item(i).Text = strItemTag Then

                                Call tbbtnBookmarkItemsTagUpdaten(.Item(i).Tag)

                                'bei Übereinstimmung entsprechend löschen
                                .Remove(.Item(i))
                                With Me.tbbtnDelBookmarkItem.DropDownItems
                                    .Remove(.Item(i))
                                End With
                                Exit For
                            End If
                        Next
                        Call tbbtnBookmarkItemsUpdaten()
                    End If
                End With

            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub
#End Region

#Region "tbbtnBookmarkItems updaten"
    Private Sub tbbtnBookmarkItemsTagUpdaten(ByVal ItemTag As String)

        Dim ArrayBookmarkTag() As String = Split(ItemTag, "|")
        Dim OZähler As Integer = -1
        For x As Integer = 0 To ArrayBookmarkTag.Length - 1
            If ArrayBookmarkTag(x) <> "" Then
                OZähler += 1
                ArrayBookmarkTag(OZähler) = ArrayBookmarkTag(x)
            End If
        Next

        ReDim Preserve ArrayBookmarkTag(OZähler)
        'Ergebnis
        'ArrayBookmarkTag(0) = Start-Position des Lesezeichens
        'ArrayBookmarkTag(1) = Position des 1. Zeichens der entsprechenden Zeile
        'ArrayBookmarkTag(2) = Start-Position oder Text des Lesezeichens


        Dim ArrayTag() As String = Split(Me.tbbtnBookmarkItems.Tag, "|")
        OZähler = -1
        For x As Integer = 0 To ArrayTag.Length - 1
            If ArrayTag(x) <> "" Then
                OZähler += 1
                ArrayTag(OZähler) = ArrayTag(x)
            End If
        Next

        ReDim Preserve ArrayTag(OZähler)
        'Ergebnis
        'ArrayTag(0) = Start-Position des Lesezeichens
        'ArrayTag(1) = Position des 1. Zeichens der entsprechenden Zeile
        'ArrayTag(2) = Start-Position oder Text des Lesezeichens

        'prüfen ob der tbbtnBookmarkItems.Tag gleich dem zu löschenden Item.Tag entspricht
        If ArrayBookmarkTag(0) = ArrayTag(0) And _
               ArrayBookmarkTag(1) = ArrayTag(1) And _
               ArrayBookmarkTag(2) = ArrayTag(2) Then
            With Me
                'entsprechend ändern
                'um bei einem Klick auf den tbbtnBookmarkItems-Button
                'das Anspingen dieses Lesezeichens zu verhindern
                'Tag löschen
                .tbbtnBookmarkItems.Tag = ""
                .tbbtnBookmarkItems.ToolTipText = "gehe zu Lesezeichen..."
            End With
        End If
    End Sub

    Public Sub tbbtnBookmarkItemsUpdaten()
        With Me.tbbtnBookmarkItems
            .Enabled = (.DropDownItems.Count > 0)
            If .DropDownItems.Count = 0 Then
                .Tag = ""
                .ToolTipText = "gehe zu Lesezeichen..."
            End If
            Me.tbbtnDelBookmark.Enabled = .Enabled
            Me.tbbtnDelBookmarkItem.Enabled = .Enabled
        End With
    End Sub
#End Region

#Region "alle Lesezeichen löschen"
    Private Sub tbbtnDelBookmark_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbbtnDelBookmark.Click
        Call DelBookmarks()
    End Sub

    Private Sub DelBookmarks()
        With Me.tbbtnBookmarkItems.DropDownItems
            If .Count > 0 Then
                For i As Integer = .Count - 1 To 0 Step -1
                    .Remove(.Item(i))
                    With Me.tbbtnDelBookmarkItem.DropDownItems
                        .Remove(.Item(i))
                    End With
                Next
                Call tbbtnBookmarkItemsUpdaten()
            End If
        End With
    End Sub
#End Region

#End Region

End Class
